CREATE OR REPLACE PROCEDURE GERA_PREVISAO_CONSUMO_TURNO
(P_CDFILIALOL VARCHAR2,
 P_DATAINI DATE,
 P_DATAFIN DATE,
 P_NRLISTASERV VARCHAR2,
 P_CDOPERADOR VARCHAR2
)
AS
   V_NRCONSPLAN VARCHAR2(10); -- nmero da consplan gerada para todas as filiais e servios atendidos pela O.L.
   V_SEQUENCIAL VARCHAR2(20); -- sequencial da novo cdigo
   FUNCTION QUANTIDADE_A_ATUALIZAR RETURN NUMBER
   AS
      V_QTDE NUMBER;
   BEGIN
      SELECT COUNT(1)
        INTO V_QTDE
        FROM
      (
      SELECT -- ----------------------------  --
             -- PRODUTO DE COMPRA
             -- ---------------------------- --
             (
             SELECT MIN(PT.CDPRODUTO)
              FROM PARAMPRODSUP P
                   INNER JOIN PRODUTO PT ON PT.CDPRODUTO = P.CDPRODUTO
                   INNER JOIN
                   -- Menor fator de correo
                    (SELECT P1.CDFILIAL, PT1.CDPRODESTO, MAX(Q.QUANTIDADE) QUANTIDADE, MIN(PT1.VRFATOCONV) VRFATOCONV
                      FROM PARAMPRODSUP P1
                           INNER JOIN PRODUTO PT1 ON PT1.CDPRODUTO = P1.CDPRODUTO
                           INNER JOIN
                           -- Quantidade de produtos
                           (SELECT P2.CDFILIAL, PT2.CDPRODESTO, COUNT(1) QUANTIDADE
                              FROM PARAMPRODSUP P2
                                   INNER JOIN PRODUTO PT2 ON PT2.CDPRODUTO = P2.CDPRODUTO
                             WHERE P2.CDFILIOPELOG = P_CDFILIALOL
                               AND PT2.IDPRCMPATIVO = 'S'
                             GROUP BY P2.CDFILIAL, PT2.CDPRODESTO) Q ON Q.CDFILIAL = P1.CDFILIAL AND
                                                                        Q.CDPRODESTO = PT1.CDPRODESTO
                     WHERE P1.CDFILIOPELOG = P_CDFILIALOL
                       -- Utiliza o produto de estoque apenas se ele for o nico associado  O.L.
                       AND ( ( Q.QUANTIDADE > 1 AND PT1.CDPRODESTO <> PT1.CDPRODUTO) OR (Q.QUANTIDADE <= 1) )
                       AND PT1.IDPRCMPATIVO = 'S'
                     GROUP BY P1.CDFILIAL, PT1.CDPRODESTO) M ON M.CDFILIAL = P.CDFILIAL AND
                                                                M.CDPRODESTO = PT.CDPRODESTO
                   WHERE P.CDFILIAL = CDFILICPLA
                     AND P.CDFILIOPELOG = P_CDFILIALOL
                     AND PT.CDPRODESTO = CDPRODCPLA
                     -- Utiliza o produto de estoque apenas se ele for o nico associado  O.L.s
                     AND ( ( M.QUANTIDADE > 1 AND PT.CDPRODESTO <> PT.CDPRODUTO) OR (M.QUANTIDADE <= 1) )
                     AND PT.IDPRCMPATIVO = 'S'
                     AND PT.VRFATOCONV = M.VRFATOCONV
               ) CDPRODCOMPRA
       FROM
      (
      SELECT C.CDPRODCPLA, C.CDFILICPLA, C.CDSERVCPLA, C.DTCONSPLAN, PS.CDGRUPPROD,
                T.CDTURNO,
                CASE WHEN T.CDTURNO = '1' THEN NVL(C.QTCONSPLANT1, 0.00)
                     WHEN T.CDTURNO = '2' THEN NVL(C.QTCONSPLANT2, 0.00)
                     WHEN T.CDTURNO = '3' THEN NVL(C.QTCONSPLANT3, 0.00)
                     WHEN T.CDTURNO = '4' THEN NVL(C.QTCONSPLANT4, 0.00)
                     ELSE 0.00
                END AS QUANTIDADE
           FROM CONSPLAN C
                INNER JOIN FILIAL F ON F.CDFILIAL = C.CDFILICPLA
                INNER JOIN PARASUPRI PS ON PS.CDFILIAL = NVL(F.CDFILCENTCMP, F.CDFILIAL)
                INNER JOIN TURNOSERV T ON T.CDFILIAL = C.CDFILICPLA AND
                                          T.CDSERVFILI = C.CDSERVCPLA
          WHERE C.NRCONSPLAN = V_NRCONSPLAN
            AND NVL(C.QTCONSPLANT1, 0.00) + NVL(C.QTCONSPLANT2, 0.00) + NVL(C.QTCONSPLANT3, 0.00) + NVL(C.QTCONSPLANT4, 0.00) <> 0.00
            AND EXISTS (SELECT 1 FROM PARAMPRODSUP
                         WHERE CDFILIAL = C.CDFILICPLA
                           AND CDFILIOPELOG = P_CDFILIALOL
                           AND CDPRODUTO = C.CDPRODCPLA)
            AND CASE WHEN T.CDTURNO = '1' THEN NVL(C.QTCONSPLANT1, 0.00)
                     WHEN T.CDTURNO = '2' THEN NVL(C.QTCONSPLANT2, 0.00)
                     WHEN T.CDTURNO = '3' THEN NVL(C.QTCONSPLANT3, 0.00)
                     WHEN T.CDTURNO = '4' THEN NVL(C.QTCONSPLANT4, 0.00)
                     ELSE 0.00
                END <> 0.00
         UNION ALL
         -- Consumo fixo
         SELECT C.CDPRODCPLA, C.CDFILICPLA, C.CDSERVCPLA, C.DTCONSPLAN, PS.CDGRUPPROD,
                T.CDTURNO,
                NVL(C.QTCONSPLAN, 0.00) AS QUANTIDADE
           FROM CONSPLAN C
                INNER JOIN FILIAL F ON F.CDFILIAL = C.CDFILICPLA
                INNER JOIN PARASUPRI PS ON PS.CDFILIAL = NVL(F.CDFILCENTCMP, F.CDFILIAL)
                INNER JOIN (SELECT CDFILIAL, CDSERVFILI, MIN(CDTURNO) AS CDTURNO
                              FROM TURNOSERV
                             GROUP BY CDFILIAL, CDSERVFILI) T ON T.CDFILIAL = C.CDFILICPLA AND
                                                                 T.CDSERVFILI = C.CDSERVCPLA
          WHERE C.NRCONSPLAN = V_NRCONSPLAN
            AND NVL(C.QTCONSPLANT1, 0.00) + NVL(C.QTCONSPLANT2, 0.00) + NVL(C.QTCONSPLANT3, 0.00) + NVL(C.QTCONSPLANT4, 0.00) = 0.00
            AND EXISTS (SELECT 1 FROM PARAMPRODSUP
                         WHERE CDFILIAL = C.CDFILICPLA
                           AND CDFILIOPELOG = P_CDFILIALOL
                           AND CDPRODUTO = C.CDPRODCPLA)
            AND NVL(C.QTCONSPLAN, 0.00) <> 0.00
      ) S
      GROUP BY CDPRODCPLA, CDFILICPLA, CDSERVCPLA, DTCONSPLAN, CDGRUPPROD, CDTURNO
      )SS INNER JOIN PRODUTO P ON P.CDPRODUTO = SS.CDPRODCOMPRA
      WHERE NVL(P.VRFATOCONV, 0.00) <> 0.00;
      RETURN V_QTDE;
   END;
BEGIN
   -- Apaga as previses de consumo por turno para regerao
   DELETE FROM PREVCONSTURNO
    WHERE DTPREVCONS BETWEEN P_DATAINI AND P_DATAFIN
      AND EXISTS(SELECT 1
                   FROM LISTA L
                  WHERE L.NRLISTA = P_NRLISTASERV
                    AND SUBSTR(L.CDLISTA, 1, 4) = PREVCONSTURNO.CDFILIAL
                    AND SUBSTR(L.CDLISTA, 5, 5) = PREVCONSTURNO.CDSERVFILI);
   -- Gera as informaes de consumo para os servios atendidos pela O.L.
   CONSPLAN_GERAL
   (P_NRLISTASERV,
    P_DATAINI,
    P_DATAFIN,
    'CFP',
    'N',
    0,
    'N',
    ' ',
    'zzzzzzzzzz',
    P_CDOPERADOR,
    'GERANOVCOD',
    V_NRCONSPLAN);
    NOVO_CODIGO('PREVCONSTURNO', V_SEQUENCIAL, QUANTIDADE_A_ATUALIZAR);
    -- Cardapio e consumo per capita
   INSERT INTO PREVCONSTURNO (NRPREVCONSTURNO, CDFILIAL, CDSERVFILI, CDPRODUTO, DTPREVCONS,
                           CDOPERADOR, CDFILIOPELOG, CDGRUPPROD, CDSUBGRPROD, CDTURNO,
                           QTPREVCONS, QTCOMPLPRODPREV,
                           CDOPERINCLUSAO, DTINCLUSAO,
                           CDOPERULTATU, DTULTATU)
   SELECT TO_NUMBER(V_SEQUENCIAL) + ROWNUM, SS.CDFILICPLA, SS.CDSERVCPLA, SS.CDPRODCPLA, SS.DTCONSPLAN,
          P_CDOPERADOR, P_CDFILIALOL, SS.CDGRUPPROD, SS.CDSUBGRPROD, SS.CDTURNO,
          CEIL(
             -- QUANTIDADE NA EMBALAGEM ESCOLHIDA
             CASE WHEN NVL(P.VRFATOCONV, 0.00) = 0.00 THEN 0.00
                  ELSE CEIL(SS.QUANTIDADE/P.VRFATOCONV) * P.VRFATOCONV
             END /
             -- ARREDONDAMENTO DO COMPRAS
             CASE WHEN NVL(P.VRARREDCMP, 0.00) = 0.00 THEN 1.0 ELSE P.VRARREDCMP END
          ) * CASE WHEN NVL(P.VRARREDCMP, 0.00) = 0.00 THEN 1.0 ELSE P.VRARREDCMP END          
          AS QUANTIDADE, 
          0.00,
          P_CDOPERADOR, SYSDATE,
          P_CDOPERADOR, SYSDATE
     FROM
   (
   SELECT CDPRODCPLA, CDFILICPLA, CDSERVCPLA, DTCONSPLAN, CDGRUPPROD,
          (SELECT CDSUBGRPROD FROM PRSUBGRPROD WHERE CDGRUPPROD = S.CDGRUPPROD
                                                         AND CDPRODUTO = S.CDPRODCPLA
                                                         AND ROWNUM = 1) AS CDSUBGRPROD,
          -- ----------------------------  --
             -- PRODUTO DE COMPRA
             -- ---------------------------- --
             (
             SELECT MIN(PT.CDPRODUTO)
              FROM PARAMPRODSUP P
                   INNER JOIN PRODUTO PT ON PT.CDPRODUTO = P.CDPRODUTO
                   INNER JOIN
                   -- Menor fator de correo
                    (SELECT P1.CDFILIAL, PT1.CDPRODESTO, MAX(Q.QUANTIDADE) QUANTIDADE, MIN(PT1.VRFATOCONV) VRFATOCONV
                      FROM PARAMPRODSUP P1
                           INNER JOIN PRODUTO PT1 ON PT1.CDPRODUTO = P1.CDPRODUTO
                           INNER JOIN
                           -- Quantidade de produtos
                           (SELECT P2.CDFILIAL, PT2.CDPRODESTO, COUNT(1) QUANTIDADE
                              FROM PARAMPRODSUP P2
                                   INNER JOIN PRODUTO PT2 ON PT2.CDPRODUTO = P2.CDPRODUTO
                             WHERE P2.CDFILIOPELOG = P_CDFILIALOL
                               AND PT2.IDPRCMPATIVO = 'S'
                             GROUP BY P2.CDFILIAL, PT2.CDPRODESTO) Q ON Q.CDFILIAL = P1.CDFILIAL AND
                                                                        Q.CDPRODESTO = PT1.CDPRODESTO
                     WHERE P1.CDFILIOPELOG = P_CDFILIALOL
                       -- Utiliza o produto de estoque apenas se ele for o nico associado  O.L.
                       AND ( ( Q.QUANTIDADE > 1 AND PT1.CDPRODESTO <> PT1.CDPRODUTO) OR (Q.QUANTIDADE <= 1) )
                       AND PT1.IDPRCMPATIVO = 'S'
                     GROUP BY P1.CDFILIAL, PT1.CDPRODESTO) M ON M.CDFILIAL = P.CDFILIAL AND
                                                                M.CDPRODESTO = PT.CDPRODESTO
                   WHERE P.CDFILIAL = CDFILICPLA
                     AND P.CDFILIOPELOG = P_CDFILIALOL
                     AND PT.CDPRODESTO = CDPRODCPLA
                     -- Utiliza o produto de estoque apenas se ele for o nico associado  O.L.s
                     AND ( ( M.QUANTIDADE > 1 AND PT.CDPRODESTO <> PT.CDPRODUTO) OR (M.QUANTIDADE <= 1) )
                     AND PT.IDPRCMPATIVO = 'S'
                     AND PT.VRFATOCONV = M.VRFATOCONV
               ) CDPRODCOMPRA,
          CDTURNO, ROUND(SUM(QUANTIDADE), 3) AS QUANTIDADE
    FROM
   (
   SELECT C.CDPRODCPLA, C.CDFILICPLA, C.CDSERVCPLA, C.DTCONSPLAN, PS.CDGRUPPROD,
             T.CDTURNO,
             CASE WHEN T.CDTURNO = '1' THEN NVL(C.QTCONSPLANT1, 0.00)
                  WHEN T.CDTURNO = '2' THEN NVL(C.QTCONSPLANT2, 0.00)
                  WHEN T.CDTURNO = '3' THEN NVL(C.QTCONSPLANT3, 0.00)
                  WHEN T.CDTURNO = '4' THEN NVL(C.QTCONSPLANT4, 0.00)
                  ELSE 0.00
             END AS QUANTIDADE
        FROM CONSPLAN C
             INNER JOIN FILIAL F ON F.CDFILIAL = C.CDFILICPLA
             INNER JOIN PARASUPRI PS ON PS.CDFILIAL = NVL(F.CDFILCENTCMP, F.CDFILIAL)
             INNER JOIN TURNOSERV T ON T.CDFILIAL = C.CDFILICPLA AND
                                       T.CDSERVFILI = C.CDSERVCPLA
       WHERE C.NRCONSPLAN = V_NRCONSPLAN
         AND NVL(C.QTCONSPLANT1, 0.00) + NVL(C.QTCONSPLANT2, 0.00) + NVL(C.QTCONSPLANT3, 0.00) + NVL(C.QTCONSPLANT4, 0.00) <> 0.00
         AND EXISTS (SELECT 1 FROM PARAMPRODSUP
                      WHERE CDFILIAL = C.CDFILICPLA
                        AND CDFILIOPELOG = P_CDFILIALOL
                        AND CDPRODUTO = C.CDPRODCPLA)
         AND CASE WHEN T.CDTURNO = '1' THEN NVL(C.QTCONSPLANT1, 0.00)
                  WHEN T.CDTURNO = '2' THEN NVL(C.QTCONSPLANT2, 0.00)
                  WHEN T.CDTURNO = '3' THEN NVL(C.QTCONSPLANT3, 0.00)
                  WHEN T.CDTURNO = '4' THEN NVL(C.QTCONSPLANT4, 0.00)
                  ELSE 0.00
             END <> 0.00
      UNION ALL
      -- Consumo fixo
      SELECT C.CDPRODCPLA, C.CDFILICPLA, C.CDSERVCPLA, C.DTCONSPLAN, PS.CDGRUPPROD,
             T.CDTURNO,
             NVL(C.QTCONSPLAN, 0.00) AS QUANTIDADE
        FROM CONSPLAN C
             INNER JOIN FILIAL F ON F.CDFILIAL = C.CDFILICPLA
             INNER JOIN PARASUPRI PS ON PS.CDFILIAL = NVL(F.CDFILCENTCMP, F.CDFILIAL)
             INNER JOIN (SELECT CDFILIAL, CDSERVFILI, MIN(CDTURNO) AS CDTURNO
                           FROM TURNOSERV
                          GROUP BY CDFILIAL, CDSERVFILI) T ON T.CDFILIAL = C.CDFILICPLA AND
                                                              T.CDSERVFILI = C.CDSERVCPLA
       WHERE C.NRCONSPLAN = V_NRCONSPLAN
         AND NVL(C.QTCONSPLANT1, 0.00) + NVL(C.QTCONSPLANT2, 0.00) + NVL(C.QTCONSPLANT3, 0.00) + NVL(C.QTCONSPLANT4, 0.00) = 0.00
         AND EXISTS (SELECT 1 FROM PARAMPRODSUP
                      WHERE CDFILIAL = C.CDFILICPLA
                        AND CDFILIOPELOG = P_CDFILIALOL
                        AND CDPRODUTO = C.CDPRODCPLA)
         AND NVL(C.QTCONSPLAN, 0.00) <> 0.00
   ) S
   GROUP BY CDPRODCPLA, CDFILICPLA, CDSERVCPLA, DTCONSPLAN, CDGRUPPROD, CDTURNO
   )SS INNER JOIN PRODUTO P ON P.CDPRODUTO = SS.CDPRODCOMPRA
   WHERE NVL(P.VRFATOCONV, 0.00) <> 0.00;
   --apaga as informaes da CONSPLAN utilizada
   DELETE FROM CONSPLAN
    WHERE NRCONSPLAN = V_NRCONSPLAN;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_PREVISAO_CONSUMO_TURNO','5.85.xxx'); END;
/