IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'GERA_PROD_ACABADO'  AND
	        TYPE = 'P'                    AND
	        U.UID = O.UID                 AND
	        U.NAME = USER
          )
  DROP PROCEDURE GERA_PROD_ACABADO
  GO

CREATE PROCEDURE GERA_PROD_ACABADO(
    @P_CDFILCENT  VARCHAR(04),
    @P_CDSERVFILI VARCHAR(05),
    @P_DTRETIRADA DATETIME,
    @P_NRCONSPLAN VARCHAR(10)
)
AS
  DECLARE @V_CDFILIAL        VARCHAR(4);
  DECLARE @V_NRLANCAMENTO    VARCHAR(20);
  DECLARE @V_IDSTATUSPRODACA VARCHAR(1);
  DECLARE @V_QUANTIDADE      FLOAT;
  DECLARE @V_DTRETIRADALANC  DATETIME;
  DECLARE @V_CDSERVFILI      VARCHAR(5);
  DECLARE @V_NRLANCPRODACA  VARCHAR(10);
  DECLARE @V_NRLANCPRODACA_PR  VARCHAR(20);
  DECLARE @V_NRCARDAPIO      VARCHAR(10);
  DECLARE @V_NRRETIRADA      VARCHAR(10);

  DECLARE @V_QTDETOTAL       FLOAT;
  DECLARE @V_VRTOTAL         FLOAT;

  DECLARE @V_CDPROD          VARCHAR(10);
  DECLARE @V_CDPRODACABADO   VARCHAR(10);
  DECLARE @V_QTPRODACABADO   FLOAT;

  DECLARE @V_NOVO_CODIGOAUX VARCHAR(20);

  /*Cursor PRODACABADO*/
  DECLARE @C_PROACA_NRCONSPLAN   VARCHAR(10);
  DECLARE @C_PROACA_CDFAPRATCPLA VARCHAR(04);
  DECLARE @C_PROACA_CDPRATCONSPL VARCHAR(10);
  DECLARE @C_PROACA_QTCONSPLAN   FLOAT;
  DECLARE @C_PROACA_NMPRATO      VARCHAR(40);
  DECLARE @C_PROACA_NMPRODUTO    VARCHAR(50);
  DECLARE @C_PROACA_SGUNIDADE    VARCHAR(10);
  DECLARE @C_PROACA_CDARVPROD    VARCHAR(20);
  DECLARE @C_PROACA_CDPRODUTO    VARCHAR(10);
  DECLARE @C_PROACA_CDFILIAL     VARCHAR(4);
  DECLARE @C_PROACA_CDFILICPLA   VARCHAR(4);
  DECLARE @C_PROACA_CDSERVFILI   VARCHAR(5);
  DECLARE @C_PROACA_CDSERVCPLA   VARCHAR(5);
  DECLARE @C_PROACA_CDTPPRATCPLA VARCHAR(2);

  /*Cursor CONSUMOFILIAL*/
  DECLARE @C_CONFIL_CDPRODUTO    VARCHAR(10);
  DECLARE @C_CONFIL_CDFILICPLA   VARCHAR(04);
  DECLARE @C_CONFIL_CDSERVCPLA   VARCHAR(05);
  DECLARE @C_CONFIL_QTCOMESTCPLA FLOAT;
  DECLARE @C_CONFIL_SGUNIDADE    VARCHAR(10);
  DECLARE @C_CONFIL_DTLIMITECPLA DATETIME;
  DECLARE @C_CONFIL_CDFILAUXPRAT VARCHAR(04);
  DECLARE @C_CONFIL_CDPRATO      VARCHAR(10);
  DECLARE @C_CONFIL_QTPADRAO     FLOAT;
  DECLARE @C_CONFIL_CDTPPRATCPLA VARCHAR(2);

  /*Cursor PRODRECEITA*/
  DECLARE @C_PROREC_CDPRATO        VARCHAR(10);
  DECLARE @C_PROREC_CDFILAUXPRAT   VARCHAR(04);
  DECLARE @C_PROREC_CDPRODUTO      VARCHAR(10);
  DECLARE @C_PROREC_CUSTOPROD      FLOAT;
  DECLARE @C_PROREC_CDFILICPLA     VARCHAR(04);
  DECLARE @C_PROREC_CDSERVCPLA     VARCHAR(05);
  DECLARE @C_PROREC_TIPO           VARCHAR(01);
  DECLARE @C_PROREC_QUANTIDADE     FLOAT;
  DECLARE @C_PROREC_QTCOMESTCPLA   FLOAT;
  DECLARE @C_PROREC_VALORTOTAL     FLOAT;
  DECLARE @C_PROREC_QTDETOTAL      FLOAT;
  DECLARE @C_PROREC_CDPRODPRODUCAO VARCHAR(10);
  DECLARE @C_PROREC_IDTPREQPROD    VARCHAR(01);
  DECLARE @C_PROREC_QTCOMPLPROD    FLOAT;
  DECLARE @C_PROREC_IDUTCOMPENTDIR VARCHAR(01);
  DECLARE @C_PROREC_DTLIMITECPLA   DATETIME;
  DECLARE @C_PROREC_CDTPPRATCPLA   VARCHAR(2);

  /*Cursor CONSFILI*/
  DECLARE @C_CONSFILI_CDPRODACABADO    VARCHAR(10);
  DECLARE @C_CONSFILI_CDFILAGREGSERV   VARCHAR(4);
  DECLARE @C_CONSFILI_CDSERVFILAGREGA  VARCHAR(5);
  DECLARE @C_CONSFILI_CDTIPOPRAT       VARCHAR(2);
  DECLARE @C_CONSFILI_CDPRATO          VARCHAR(10);
  DECLARE @C_CONSFILI_CDFILAUXPRAT     VARCHAR(4);

  /*Cursor PROACABADO*/
  DECLARE @C_PROACABADO_CDPRODACABADO    VARCHAR(10);
  DECLARE @C_PROACABADO_CDTIPOPRAT       VARCHAR(2);

BEGIN

/*Exclui Gerao de Produtos existente para essa data que no esteja com o status concludo.*/

  DELETE FROM RECPRATPRODACAB
   WHERE CDFILIAL = @P_CDFILCENT
     AND DTRETIRADALANC = @P_DTRETIRADA
     AND NOT EXISTS (SELECT CDPRODACABADO
                       FROM PRODACABAPRATO
                      WHERE RECPRATPRODACAB.CDFILIAL = PRODACABAPRATO.CDFILIAL
                        AND RECPRATPRODACAB.DTRETIRADALANC = PRODACABAPRATO.DTRETIRADALANC
                        AND RECPRATPRODACAB.CDPRODACABADO = PRODACABAPRATO.CDPRODACABADO
                        AND PRODACABAPRATO.IDSTATUSPRODACA = 'C');

  DELETE FROM CONSFILIAGREGA
   WHERE CDFILIAL = @P_CDFILCENT
     AND DTRETIRADALANC = @P_DTRETIRADA
     AND NOT EXISTS (SELECT CDPRODACABADO
                       FROM PRODACABAPRATO
                      WHERE CONSFILIAGREGA.CDFILIAL = PRODACABAPRATO.CDFILIAL
                        AND CONSFILIAGREGA.DTRETIRADALANC = PRODACABAPRATO.DTRETIRADALANC
                        AND CONSFILIAGREGA.CDPRODACABADO = PRODACABAPRATO.CDPRODACABADO
                        AND PRODACABAPRATO.IDSTATUSPRODACA = 'C');

  DELETE FROM DISTRIREFEICAO
   WHERE CDFILIAL = @P_CDFILCENT
     AND DTRETIRADALANC = @P_DTRETIRADA
     AND NOT EXISTS (SELECT CDPRODACABADO
                       FROM PRODACABAPRATO
                      WHERE DISTRIREFEICAO.CDFILIAL = CDFILIAL
                        AND DISTRIREFEICAO.DTRETIRADALANC = DTRETIRADALANC
                        AND DISTRIREFEICAO.CDPRODACABADO = CDPRODACABADO
                        AND IDSTATUSPRODACA = 'C');   

  DELETE FROM PRODACABAPRATO
   WHERE CDFILIAL = @P_CDFILCENT
     AND DTRETIRADALANC = @P_DTRETIRADA
     AND IDSTATUSPRODACA <> 'C';

  SELECT @V_QUANTIDADE = COUNT(*)
    FROM PRODACABAPRATO
   WHERE CDFILIAL = @P_CDFILCENT
     AND DTRETIRADALANC = @P_DTRETIRADA;

  IF @V_QUANTIDADE = 0 BEGIN
     DELETE FROM GERAPRODACABADO
      WHERE CDFILIAL = @P_CDFILCENT
        AND DTRETIRADALANC = @P_DTRETIRADA;

  /*Inclui a Gerao de Produto Acabado ---------------------------------------- */

     /* Busca o nmero do lanamento do produto acabado */
     SET @V_NOVO_CODIGOAUX = 'GERAPRODACABADO' + @P_CDFILCENT;
     EXEC NOVO_CODIGO @V_NOVO_CODIGOAUX, @P_SEQUENCIAL = @V_NRLANCPRODACA_PR OUTPUT;
     SET @V_NRLANCPRODACA = SUBSTRING(@V_NRLANCPRODACA_PR, 11, 10);

     INSERT INTO GERAPRODACABADO
        (CDFILIAL, DTRETIRADALANC, CDSERVFILI, NRLANCPRODACA, DTLANCPRODACA)
     VALUES
        (@P_CDFILCENT, @P_DTRETIRADA, @P_CDSERVFILI, @V_NRLANCPRODACA, GETDATE());

  END;

/*Inclui os Produtos Acabados correspondentes ---------------------------------*/
  DECLARE C_PRODACABADO
   CURSOR FOR (SELECT CP.NRCONSPLAN, CP.CDFAPRATCPLA, CP.CDPRATCONSPL,
                      SUM(ISNULL(CP.QTCONSPLAN,0)) AS QTCONSPLAN,  P.NMPRATO,
                      PR.CDFILIAL, CP.CDFILICPLA, PR.CDSERVFILI, CP.CDSERVCPLA,
                      PR.NMPRODUTO, PR.SGUNIDADE, PR.CDARVPROD, PR.CDPRODUTO, CP.CDTPPRATCPLA
                 FROM CONSPLAN CP, PRATO P, (SELECT PS.CDFILAUXPRAT, PS.CDPRATO, PS.CDPRODPRODUCAO, PS.CDFILIAL, PS.CDSERVFILI, 'S' AS IDTIPO,
                                                    PO.NMPRODUTO, PO.SGUNIDADE, PO.CDARVPROD, PO.CDPRODUTO
                                               FROM PRATSERV PS, PRODUTO PO
                                              WHERE PS.CDPRODPRODUCAO = PO.CDPRODUTO
                                              UNION ALL
                                             SELECT PF.CDFILAUXPRAT, PF.CDPRATO, PF.CDPRODPRODUCAO, PF.CDFILIAL, NULL AS CDSERVFILI, 'F' AS IDTIPO,
                                                    PO.NMPRODUTO, PO.SGUNIDADE, PO.CDARVPROD, PO.CDPRODUTO
                                               FROM PRATFILI PF, PRODUTO PO
                                              WHERE PF.CDPRODPRODUCAO = PO.CDPRODUTO
                                              UNION ALL
                                             SELECT PP.CDFILAUXPRAT, PP.CDPRATO, PP.CDPRODPRODUCAO, NULL AS CDFILIAL, NULL AS CDSERVFILI, 'P' AS IDTIPO,
                                                    PO.NMPRODUTO, PO.SGUNIDADE, PO.CDARVPROD, PO.CDPRODUTO
                                               FROM PRATPADR PP, PRODUTO PO
                                              WHERE PP.CDPRODPRODUCAO = PO.CDPRODUTO) PR
                WHERE ISNULL(PR.CDFILIAL, CP.CDFILICPLA) = CP.CDFILICPLA
                  AND ISNULL(PR.CDSERVFILI, CP.CDSERVCPLA) = CP.CDSERVCPLA
                  AND PR.CDPRATO = CP.CDPRATCONSPL
                  AND PR.CDFILAUXPRAT = CP.CDFAPRATCPLA
                  AND PR.IDTIPO = TEKNISA.RECEITA_UTILIZADA(CP.CDPRATCONSPL, CP.CDFAPRATCPLA, CP.CDFILICPLA, CP.CDSERVCPLA)
                  AND P.CDPRATO = CP.CDPRATCONSPL
                  AND P.CDFILAUXPRAT = CP.CDFAPRATCPLA
                  AND CP.NRCONSPLAN = @P_NRCONSPLAN
                GROUP BY CP.NRCONSPLAN, CP.CDFAPRATCPLA, CP.CDPRATCONSPL, P.NMPRATO, PR.CDFILIAL, CP.CDFILICPLA, PR.CDSERVFILI, CP.CDSERVCPLA, PR.NMPRODUTO, PR.SGUNIDADE, PR.CDARVPROD, PR.CDPRODUTO, CP.CDTPPRATCPLA)
  OPEN C_PRODACABADO;

  FETCH NEXT FROM C_PRODACABADO INTO @C_PROACA_NRCONSPLAN, @C_PROACA_CDFAPRATCPLA, @C_PROACA_CDPRATCONSPL,
                                     @C_PROACA_QTCONSPLAN, @C_PROACA_NMPRATO, @C_PROACA_CDFILIAL, 
                                     @C_PROACA_CDFILICPLA, @C_PROACA_CDSERVFILI, @C_PROACA_CDSERVCPLA, @C_PROACA_NMPRODUTO,
                                     @C_PROACA_SGUNIDADE, @C_PROACA_CDARVPROD, @C_PROACA_CDPRODUTO, @C_PROACA_CDTPPRATCPLA;

  WHILE (@@FETCH_STATUS = 0) BEGIN
    BEGIN
       SELECT @V_IDSTATUSPRODACA = ISNULL(MAX(IDSTATUSPRODACA), 'P')
         FROM PRODACABAPRATO
        WHERE CDFILIAL = @P_CDFILCENT
          AND DTRETIRADALANC = @P_DTRETIRADA
          AND CDPRODACABADO = @C_PROACA_CDPRODUTO
          AND CDTIPOPRAT = @C_PROACA_CDTPPRATCPLA;
    END;

    IF @V_IDSTATUSPRODACA = 'P' BEGIN
       INSERT INTO PRODACABAPRATO
       (CDFILIAL, DTRETIRADALANC, CDPRODACABADO, QTPRODACABADO, IDTPPRODACABADO, CDTIPOPRAT)
       VALUES
       (@P_CDFILCENT, @P_DTRETIRADA, @C_PROACA_CDPRODUTO, 0, 'P', @C_PROACA_CDTPPRATCPLA);
    END;

    FETCH NEXT FROM C_PRODACABADO INTO @C_PROACA_NRCONSPLAN, @C_PROACA_CDFAPRATCPLA, @C_PROACA_CDPRATCONSPL,
                                       @C_PROACA_QTCONSPLAN, @C_PROACA_NMPRATO, @C_PROACA_CDFILIAL, 
                                       @C_PROACA_CDFILICPLA, @C_PROACA_CDSERVFILI, @C_PROACA_CDSERVCPLA, @C_PROACA_NMPRODUTO,
                                       @C_PROACA_SGUNIDADE, @C_PROACA_CDARVPROD, @C_PROACA_CDPRODUTO, @C_PROACA_CDTPPRATCPLA;
  END;
  DEALLOCATE C_PRODACABADO;
/*Inclui o consumo dos produtos por filial/servio -----------------------------*/

  DECLARE C_CONSUMOFILIAL CURSOR FOR
                 (SELECT DISTINCT PR.CDPRODUTO, CP.CDFILICPLA, CP.CDSERVCPLA,
                         CP.QTCOMESTCPLA, PR.SGUNIDADE,
                         CP.DTLIMITECPLA, PA.CDFILAUXPRAT, PA.CDPRATO, PR.QTPADRAO, CP.CDTPPRATCPLA
                    FROM CONSPLAN CP, PRATO PA,
                         (SELECT PS.CDFILAUXPRAT, PS.CDPRATO, PS.CDPRODPRODUCAO, PS.CDFILIAL, PS.CDSERVFILI, 'S' AS IDTIPO,
                                 PO.NMPRODUTO, PO.SGUNIDADE, PO.CDARVPROD, PO.CDPRODUTO, MAX(ISNULL(PS.QTPADRAOSERV, 0)) AS QTPADRAO
                             FROM PRATSERV PS, PRODUTO PO
                            WHERE PS.CDPRODPRODUCAO = PO.CDPRODUTO
                          GROUP BY PS.CDFILAUXPRAT, PS.CDPRATO, PS.CDPRODPRODUCAO, PS.CDFILIAL, PS.CDSERVFILI, 
                                   PO.NMPRODUTO, PO.SGUNIDADE, PO.CDARVPROD, PO.CDPRODUTO
                          UNION ALL
                          SELECT PF.CDFILAUXPRAT, PF.CDPRATO, PF.CDPRODPRODUCAO, PF.CDFILIAL, NULL AS CDSERVFILI, 'F' AS IDTIPO,
                                 PO.NMPRODUTO, PO.SGUNIDADE, PO.CDARVPROD, PO.CDPRODUTO, MAX(ISNULL(PF.QTPADRAOFILI, 0)) AS QTPADRAO
                            FROM PRATFILI PF, PRODUTO PO
                           WHERE PF.CDPRODPRODUCAO = PO.CDPRODUTO
                          GROUP BY PF.CDFILAUXPRAT, PF.CDPRATO, PF.CDPRODPRODUCAO, PF.CDFILIAL,
                                   PO.NMPRODUTO, PO.SGUNIDADE, PO.CDARVPROD, PO.CDPRODUTO
                          UNION ALL
                          SELECT PP.CDFILAUXPRAT, PP.CDPRATO, PP.CDPRODPRODUCAO, NULL AS CDFILIAL, NULL AS CDSERVFILI, 'P' AS IDTIPO,
                                 PO.NMPRODUTO, PO.SGUNIDADE, PO.CDARVPROD, PO.CDPRODUTO, MAX(ISNULL(PP.QTPADRAOPRAT, 0)) AS QTPADRAO
                            FROM PRATPADR PP, PRODUTO PO
                           WHERE PP.CDPRODPRODUCAO = PO.CDPRODUTO
                          GROUP BY PP.CDFILAUXPRAT, PP.CDPRATO, PP.CDPRODPRODUCAO,
                                   PO.NMPRODUTO, PO.SGUNIDADE, PO.CDARVPROD, PO.CDPRODUTO) PR
                   WHERE ISNULL(PR.CDFILIAL, CP.CDFILICPLA) = CP.CDFILICPLA
                     AND ISNULL(PR.CDSERVFILI, CP.CDSERVCPLA) = CP.CDSERVCPLA
                     AND PR.CDPRATO = CP.CDPRATCONSPL
                     AND PR.CDFILAUXPRAT = CP.CDFAPRATCPLA
                     AND PR.IDTIPO = TEKNISA.RECEITA_UTILIZADA(CP.CDPRATCONSPL, CP.CDFAPRATCPLA, CP.CDFILICPLA, CP.CDSERVCPLA)
                     AND CP.CDFAPRATCPLA = PA.CDFILAUXPRAT
                     AND CP.CDPRATCONSPL = PA.CDPRATO
                     AND CP.NRCONSPLAN = @P_NRCONSPLAN)
  OPEN C_CONSUMOFILIAL;

  FETCH NEXT FROM C_CONSUMOFILIAL INTO @C_CONFIL_CDPRODUTO, @C_CONFIL_CDFILICPLA, @C_CONFIL_CDSERVCPLA,
                                       @C_CONFIL_QTCOMESTCPLA, @C_CONFIL_SGUNIDADE, @C_CONFIL_DTLIMITECPLA,
                                       @C_CONFIL_CDFILAUXPRAT, @C_CONFIL_CDPRATO, @C_CONFIL_QTPADRAO,
                                       @C_CONFIL_CDTPPRATCPLA;

  WHILE (@@FETCH_STATUS = 0) BEGIN
    BEGIN
       SELECT @V_IDSTATUSPRODACA = ISNULL(MAX(IDSTATUSPRODACA), 'P')
         FROM PRODACABAPRATO
        WHERE CDFILIAL = @P_CDFILCENT
          AND DTRETIRADALANC = @P_DTRETIRADA
          AND CDPRODACABADO = @C_CONFIL_CDPRODUTO
          AND CDTIPOPRAT = @C_CONFIL_CDTPPRATCPLA;
    END;

    IF @V_IDSTATUSPRODACA = 'P' BEGIN
       INSERT INTO CONSFILIAGREGA
       (CDFILIAL, DTRETIRADALANC, CDPRODACABADO, CDFILAGREGSERV,
        CDSERVFILAGREGA, QTPRODSERVCONS, DTENTRPRODSERV, QTCOMESERVCONS, CDTIPOPRAT, CDPRATO, CDFILAUXPRAT)
       VALUES
       (@P_CDFILCENT, @P_DTRETIRADA, @C_CONFIL_CDPRODUTO, @C_CONFIL_CDFILICPLA,
        @C_CONFIL_CDSERVCPLA, @C_CONFIL_QTPADRAO*@C_CONFIL_QTCOMESTCPLA, @C_CONFIL_DTLIMITECPLA,
        @C_CONFIL_QTCOMESTCPLA, @C_CONFIL_CDTPPRATCPLA, @C_CONFIL_CDPRATO, @C_CONFIL_CDFILAUXPRAT);

       BEGIN
        SELECT @V_CDPROD = CDPRODUTO
         FROM PRODFILI
        WHERE CDFILIAL = @C_CONFIL_CDFILICPLA
          AND CDPRODUTO = @C_CONFIL_CDPRODUTO;
 
          IF @V_CDPROD IS NULL BEGIN
             INSERT INTO PRODFILI (CDFILIAL, CDPRODUTO, IDCNTRESTOQ, IDPRODATIV)
                           VALUES (@C_CONFIL_CDFILICPLA, @C_CONFIL_CDPRODUTO, 'S', 'A');
          END;
       END;
    END;

    FETCH NEXT FROM C_CONSUMOFILIAL INTO @C_CONFIL_CDPRODUTO, @C_CONFIL_CDFILICPLA, @C_CONFIL_CDSERVCPLA,
                                         @C_CONFIL_QTCOMESTCPLA, @C_CONFIL_SGUNIDADE, @C_CONFIL_DTLIMITECPLA,
                                         @C_CONFIL_CDFILAUXPRAT, @C_CONFIL_CDPRATO, @C_CONFIL_QTPADRAO,
                                         @C_CONFIL_CDTPPRATCPLA;
  END;
  DEALLOCATE C_CONSUMOFILIAL;
/*Inclui os produtos utilizados na receita -------------------------------------*/

  DECLARE C_PRODRECEITA CURSOR FOR
                     (SELECT RC.CDPRATO,
                             RC.CDFILAUXPRAT,
                             RC.CDPRODUTO,
                             ROUND(ISNULL(TEKNISA.CUSTO_PRODUTO(@P_CDFILCENT, RC.CDPRODUTO, CASE PF.CDTIPCUSTEST WHEN '' THEN '03' ELSE PF.CDTIPCUSTEST END, CP.DTCONSPLAN, GETDATE()), 0),5) AS CUSTOPROD,
                             RC.CDFILICPLA,
                             RC.CDSERVCPLA,
                             RC.TIPO,
                             RC.QTPRODUTO AS QUANTIDADE,
                             RC.QTCOMESTCPLA,
                             RC.QTPRODUTO * RC.QTCOMESTCPLA * ROUND(ISNULL(TEKNISA.CUSTO_PRODUTO(@P_CDFILCENT, RC.CDPRODUTO, CASE PF.CDTIPCUSTEST WHEN '' THEN '03' ELSE PF.CDTIPCUSTEST END, CP.DTCONSPLAN, GETDATE()), 0),5) AS VALORTOTAL,
                             RC.QTPRODUTO * RC.QTCOMESTCPLA AS QTDETOTAL,
                             RC.CDPRODPRODUCAO,
                             ISNULL(RC.IDTPREQPROD, 'P') AS IDTPREQPROD,
                             ISNULL(RC.QTCOMPLPROD, 0) AS QTCOMPLPROD,
                             ISNULL(RC.IDUTCOMPENTDIR, 'N') AS IDUTCOMPENTDIR,
                             CP.DTLIMITECPLA,
                             RC.CDTPPRATCPLA
                        FROM PRODUTO PD, PARAMFILIAL PF, CONSPLAN CP, PRODUTO PP,
                             (SELECT R.CDPRATO, R.CDFILAUXPRAT, R.CDPRODUTO, R.QTPRODRECSER AS QTPRODUTO,
                                     R.SGUNIDADE, 'S' AS TIPO, CP.CDFILICPLA, CP.CDSERVCPLA,
                                     SUM(CP.QTCOMESTCPLA) AS QTCOMESTCPLA, CP.NRCONSPLAN, R.IDTPREQPRODSERV AS IDTPREQPROD,
                                     R.QTCOMPLPRODSERV AS QTCOMPLPROD, R.IDUTCOMPENTDIRS AS IDUTCOMPENTDIR, PS.CDPRODPRODUCAO, CP.CDTPPRATCPLA
                                FROM RECESERV R, COMPCARD C, CARDADIA D, CONSPLAN CP, PRATSERV PS
                               WHERE (D.CDFILIAL     = CP.CDFILICPLA)
                                 AND (D.CDSERVFILI   = CP.CDSERVCPLA)
                                 AND (D.DTCARDAPIO   = CP.DTCONSPLAN)
                                 AND (C.CDFILIAL     = D.CDFILIAL)
                                 AND (C.NRCARDAPIO   = D.NRCARDAPIO)
                                 AND (R.CDFILIAL     = CP.CDFILICPLA)
                                 AND (R.CDSERVFILI   = CP.CDSERVCPLA)
                                 AND (R.CDFILAUXPRAT = C.CDFILAUXPRAT)
                                 AND (R.CDPRATO      = C.CDPRATO)
                                 AND (R.CDFILAUXPRAT = CP.CDFAPRATCPLA)
                                 AND (R.CDPRATO      = CP.CDPRATCONSPL)
                                 AND (R.CDFILAUXPRAT = PS.CDFILAUXPRAT)
                                 AND (R.CDPRATO      = PS.CDPRATO)
                                 AND (R.CDFILIAL     = PS.CDFILIAL)
                                 AND (R.CDSERVFILI   = PS.CDSERVFILI)
                                 AND (CP.CDPRODCPLA  = R.CDPRODUTO)
                                 AND (CP.NRCONSPLAN = @P_NRCONSPLAN)
                              GROUP BY R.CDPRATO, R.CDFILAUXPRAT, R.CDPRODUTO, R.QTPRODRECSER,
                                       R.SGUNIDADE, CP.CDFILICPLA, CP.CDSERVCPLA, CP.NRCONSPLAN,
                                       R.IDTPREQPRODSERV, R.QTCOMPLPRODSERV, R.IDUTCOMPENTDIRS, PS.CDPRODPRODUCAO, CP.CDTPPRATCPLA
                              UNION ALL
                              SELECT R.CDPRATO, R.CDFILAUXPRAT, R.CDPRODUTO, R.QTPRODRECLOC AS QTPRODUTO,
                                     R.SGUNIDADE, 'F' AS TIPO, CP.CDFILICPLA, CP.CDSERVCPLA,
                                     SUM(CP.QTCOMESTCPLA) AS QTCOMESTCPLA, CP.NRCONSPLAN, R.IDTPREQPRODFILI AS IDTPREQPROD,
                                     R.QTCOMPLPRODFILI AS QTCOMPLPROD, R.IDUTCOMPENTDIRF AS IDUTCOMPENTDIR, PF.CDPRODPRODUCAO, CP.CDTPPRATCPLA
                                FROM RECEFILI R, COMPCARD C, CARDADIA D, CONSPLAN CP, PRATFILI PF
                               WHERE (D.CDFILIAL     = CP.CDFILICPLA)
                                 AND (D.CDSERVFILI   = CP.CDSERVCPLA)
                                 AND (D.DTCARDAPIO   = CP.DTCONSPLAN)
                                 AND (C.CDFILIAL     = D.CDFILIAL)
                                 AND (C.NRCARDAPIO   = D.NRCARDAPIO)
                                 AND (R.CDFILIAL     = CP.CDFILICPLA)
                                 AND (R.CDFILAUXPRAT = C.CDFILAUXPRAT)
                                 AND (R.CDPRATO      = C.CDPRATO)
                                 AND (R.CDFILAUXPRAT = CP.CDFAPRATCPLA)
                                 AND (R.CDPRATO      = CP.CDPRATCONSPL)
                                 AND (R.CDFILAUXPRAT = PF.CDFILAUXPRAT)
                                 AND (R.CDPRATO      = PF.CDPRATO)
                                 AND (R.CDFILIAL     = PF.CDFILIAL)
                                 AND (CP.CDPRODCPLA  = R.CDPRODUTO)
                                 AND (CP.NRCONSPLAN = @P_NRCONSPLAN)
                                 AND NOT EXISTS (SELECT CDPRATO
                                                   FROM RECESERV
                                                  WHERE (CDFILAUXPRAT = R.CDFILAUXPRAT)
                                                    AND (CDPRATO      = R.CDPRATO)
                                                    AND (CDFILIAL     = CP.CDFILICPLA)
                                                    AND (CDSERVFILI   = CP.CDSERVCPLA))
                              GROUP BY R.CDPRATO, R.CDFILAUXPRAT, R.CDPRODUTO, R.QTPRODRECLOC,
                                       R.SGUNIDADE, CP.CDFILICPLA, CP.CDSERVCPLA, CP.NRCONSPLAN,
                                       R.IDTPREQPRODFILI, R.QTCOMPLPRODFILI, R.IDUTCOMPENTDIRF, PF.CDPRODPRODUCAO, CP.CDTPPRATCPLA
                              UNION ALL
                              SELECT R.CDPRATO, R.CDFILAUXPRAT, R.CDPRODUTO, R.QTPRODPRAT AS QTPRODUTO,
                                     R.SGUNIDADE, 'P' AS TIPO, CP.CDFILICPLA, CP.CDSERVCPLA,
                                     SUM(CP.QTCOMESTCPLA) AS QTCOMESTCPLA, CP.NRCONSPLAN, R.IDTPREQPRODPADR AS IDTPREQPROD,
                                     R.QTCOMPLPRODPADR AS QTCOMPLPROD, R.IDUTCOMPENTDIRP AS IDUTCOMPENTDIR, PP.CDPRODPRODUCAO, CP.CDTPPRATCPLA
                                FROM RECEPADR R, COMPCARD C, CARDADIA D, CONSPLAN CP, PRATPADR PP
                               WHERE (D.CDFILIAL     = CP.CDFILICPLA)
                                 AND (D.CDSERVFILI   = CP.CDSERVCPLA)
                                 AND (D.DTCARDAPIO   = CP.DTCONSPLAN)
                                 AND (C.CDFILIAL     = D.CDFILIAL)
                                 AND (C.NRCARDAPIO   = D.NRCARDAPIO)
                                 AND (R.CDFILAUXPRAT = C.CDFILAUXPRAT)
                                 AND (R.CDPRATO      = C.CDPRATO)
                                 AND (R.CDFILAUXPRAT = CP.CDFAPRATCPLA)
                                 AND (R.CDPRATO      = CP.CDPRATCONSPL)
                                 AND (R.CDFILAUXPRAT = PP.CDFILAUXPRAT)
                                 AND (R.CDPRATO      = PP.CDPRATO)
                                 AND (CP.CDPRODCPLA  = R.CDPRODUTO)
                                 AND (CP.NRCONSPLAN  = @P_NRCONSPLAN)
                                 AND NOT EXISTS (SELECT CDPRATO
                                                   FROM RECEFILI
                                                  WHERE (CDFILAUXPRAT = R.CDFILAUXPRAT)
                                                    AND (CDPRATO      = R.CDPRATO)
                                                    AND (CDFILIAL     = CP.CDFILICPLA))
                                 AND NOT EXISTS (SELECT CDPRATO
                                                   FROM RECESERV
                                                  WHERE (CDFILAUXPRAT = R.CDFILAUXPRAT)
                                                    AND (CDPRATO      = R.CDPRATO)
                                                    AND (CDFILIAL     = CP.CDFILICPLA)
                                                    AND (CDSERVFILI   = CP.CDSERVCPLA))
                              GROUP BY R.CDPRATO, R.CDFILAUXPRAT, R.CDPRODUTO, R.QTPRODPRAT,
                                       R.SGUNIDADE, CP.CDFILICPLA, CP.CDSERVCPLA, CP.NRCONSPLAN,
                                       R.IDTPREQPRODPADR, R.QTCOMPLPRODPADR, R.IDUTCOMPENTDIRP, PP.CDPRODPRODUCAO, CP.CDTPPRATCPLA) RC
                        WHERE (RC.CDPRODUTO    = PD.CDPRODUTO)
                          AND (PF.CDFILIAL     = @P_CDFILCENT)
                          AND (CP.NRCONSPLAN   = RC.NRCONSPLAN)
                          AND (RC.CDPRODUTO    = CP.CDPRODCPLA)
                          AND (RC.CDTPPRATCPLA = CP.CDTPPRATCPLA)
                          AND (PP.CDPRODUTO    = RC.CDPRODPRODUCAO)
                       GROUP BY RC.CDPRATO, RC.CDFILAUXPRAT, RC.CDPRODUTO, PF.CDTIPCUSTEST,
                               CP.DTCONSPLAN, RC.CDFILICPLA, RC.CDSERVCPLA, RC.TIPO, RC.QTPRODUTO,
                               RC.QTCOMESTCPLA, RC.CDPRODPRODUCAO, ISNULL(RC.IDTPREQPROD, 'P'), ISNULL(RC.QTCOMPLPROD, 0),
                               ISNULL(RC.IDUTCOMPENTDIR, 'N'), CP.DTLIMITECPLA, CP.CDTPPRATCPLA, RC.CDTPPRATCPLA)

  OPEN C_PRODRECEITA;

  FETCH NEXT FROM C_PRODRECEITA INTO @C_PROREC_CDPRATO, @C_PROREC_CDFILAUXPRAT, @C_PROREC_CDPRODUTO,
                                     @C_PROREC_CUSTOPROD, @C_PROREC_CDFILICPLA, @C_PROREC_CDSERVCPLA,
                                     @C_PROREC_TIPO, @C_PROREC_QUANTIDADE, @C_PROREC_QTCOMESTCPLA, @C_PROREC_VALORTOTAL,
                                     @C_PROREC_QTDETOTAL, @C_PROREC_CDPRODPRODUCAO, @C_PROREC_IDTPREQPROD,
                                     @C_PROREC_QTCOMPLPROD, @C_PROREC_IDUTCOMPENTDIR, @C_PROREC_DTLIMITECPLA,
                                     @C_PROREC_CDTPPRATCPLA;

  WHILE (@@FETCH_STATUS = 0) BEGIN
    IF (@C_PROREC_IDTPREQPROD = 'P') BEGIN

       BEGIN
          SELECT @V_IDSTATUSPRODACA = ISNULL(MAX(IDSTATUSPRODACA), 'P')
            FROM PRODACABAPRATO
           WHERE CDFILIAL = @P_CDFILCENT
             AND DTRETIRADALANC = @P_DTRETIRADA
             AND CDPRODACABADO = @C_PROREC_CDPRODPRODUCAO
             AND CDTIPOPRAT = @C_PROREC_CDTPPRATCPLA;
       END;

       IF @V_IDSTATUSPRODACA = 'P' BEGIN
          IF (@C_PROREC_IDUTCOMPENTDIR = 'N') BEGIN
             INSERT INTO RECPRATPRODACAB
             (CDFILIAL, DTRETIRADALANC, CDPRODACABADO, CDFILAGREGSERV, CDSERVFILAGREGA, IDRECEITAPRACA,
              CDPRODUTO, QTPRODRECEPRAT, VRUNITRECEPRAT, VRTOTARECEPRAT, QTTOTARECEPRAT, CDTIPOPRAT, CDPRATO, CDFILAUXPRAT)
             VALUES
             (@P_CDFILCENT, @P_DTRETIRADA, @C_PROREC_CDPRODPRODUCAO, @C_PROREC_CDFILICPLA, @C_PROREC_CDSERVCPLA, @C_PROREC_TIPO,
              @C_PROREC_CDPRODUTO, @C_PROREC_QUANTIDADE + @C_PROREC_QTCOMPLPROD, @C_PROREC_CUSTOPROD, @C_PROREC_VALORTOTAL, @C_PROREC_QTDETOTAL, @C_PROREC_CDTPPRATCPLA, @C_PROREC_CDPRATO, @C_PROREC_CDFILAUXPRAT);
          END
          ELSE BEGIN
             INSERT INTO RECPRATPRODACAB
             (CDFILIAL, DTRETIRADALANC, CDPRODACABADO, CDFILAGREGSERV, CDSERVFILAGREGA, IDRECEITAPRACA,
              CDPRODUTO, QTPRODRECEPRAT, VRUNITRECEPRAT, VRTOTARECEPRAT, QTTOTARECEPRAT, CDTIPOPRAT, CDPRATO, CDFILAUXPRAT)
             VALUES
             (@P_CDFILCENT, @P_DTRETIRADA, @C_PROREC_CDPRODPRODUCAO, @C_PROREC_CDFILICPLA, @C_PROREC_CDSERVCPLA, @C_PROREC_TIPO,
              @C_PROREC_CDPRODUTO, @C_PROREC_QUANTIDADE, @C_PROREC_CUSTOPROD, @C_PROREC_VALORTOTAL, @C_PROREC_QTDETOTAL, @C_PROREC_CDTPPRATCPLA, @C_PROREC_CDPRATO, @C_PROREC_CDFILAUXPRAT);
          END;
       END;
    END;

    IF (@C_PROREC_IDTPREQPROD = 'D') BEGIN

       BEGIN
          SELECT @V_IDSTATUSPRODACA = ISNULL(MAX(IDSTATUSPRODACA), 'P')
            FROM PRODACABAPRATO
           WHERE CDFILIAL = @P_CDFILCENT
             AND DTRETIRADALANC = @P_DTRETIRADA
             AND CDPRODACABADO = @C_PROREC_CDPRODUTO
             AND CDTIPOPRAT = @C_PROREC_CDTPPRATCPLA;
       END;

       IF @V_IDSTATUSPRODACA = 'P' BEGIN

          SELECT @V_CDPRODACABADO = MAX(CDPRODACABADO), @V_QTPRODACABADO = MAX(QTPRODACABADO)
          FROM PRODACABAPRATO PP
          WHERE PP.CDFILIAL = @P_CDFILCENT
          AND PP.DTRETIRADALANC = @P_DTRETIRADA
          AND PP.CDPRODACABADO = @C_PROREC_CDPRODUTO
          AND PP.CDTIPOPRAT = @C_PROREC_CDTPPRATCPLA;

          IF (@V_CDPRODACABADO IS NULL) BEGIN
             INSERT INTO PRODACABAPRATO
             (CDFILIAL, DTRETIRADALANC, CDPRODACABADO, QTPRODACABADO, IDTPPRODACABADO, CDTIPOPRAT)
             VALUES
             (@P_CDFILCENT, @P_DTRETIRADA, @C_PROREC_CDPRODUTO, @C_PROREC_QUANTIDADE + @C_PROREC_QTCOMPLPROD, 'D', @C_PROREC_CDTPPRATCPLA);
          END
          ELSE BEGIN
             UPDATE PRODACABAPRATO
             SET QTPRODACABADO = @V_QTPRODACABADO + @C_PROREC_QUANTIDADE + @C_PROREC_QTCOMPLPROD
             WHERE CDFILIAL = @P_CDFILCENT
               AND DTRETIRADALANC = @P_DTRETIRADA
               AND CDPRODACABADO = @C_PROREC_CDPRODUTO
               AND CDTIPOPRAT = @C_PROREC_CDTPPRATCPLA;
          END;

          INSERT INTO CONSFILIAGREGA
          (CDFILIAL, DTRETIRADALANC, CDPRODACABADO, CDFILAGREGSERV,
           CDSERVFILAGREGA, QTPRODSERVCONS, DTENTRPRODSERV, QTCOMESERVCONS,
           VRTOTAPRODSERV, VRUNITPRODSERV, CDTIPOPRAT, CDPRATO, CDFILAUXPRAT)
          VALUES
          (@P_CDFILCENT, @P_DTRETIRADA, @C_PROREC_CDPRODUTO, @C_PROREC_CDFILICPLA,
           @C_PROREC_CDSERVCPLA, @C_PROREC_QUANTIDADE*@C_PROREC_QTCOMESTCPLA, @C_PROREC_DTLIMITECPLA,
           @C_PROREC_QTCOMESTCPLA, @C_PROREC_VALORTOTAL, @C_PROREC_VALORTOTAL/(@C_PROREC_QUANTIDADE*@C_PROREC_QTCOMESTCPLA), @C_PROREC_CDTPPRATCPLA, @C_PROREC_CDPRATO, @C_PROREC_CDFILAUXPRAT);
       END;
    END;

    FETCH NEXT FROM C_PRODRECEITA INTO @C_PROREC_CDPRATO, @C_PROREC_CDFILAUXPRAT, @C_PROREC_CDPRODUTO,
                                     @C_PROREC_CUSTOPROD, @C_PROREC_CDFILICPLA, @C_PROREC_CDSERVCPLA,
                                     @C_PROREC_TIPO, @C_PROREC_QUANTIDADE, @C_PROREC_QTCOMESTCPLA, @C_PROREC_VALORTOTAL,
                                     @C_PROREC_QTDETOTAL, @C_PROREC_CDPRODPRODUCAO, @C_PROREC_IDTPREQPROD,
                                     @C_PROREC_QTCOMPLPROD, @C_PROREC_IDUTCOMPENTDIR, @C_PROREC_DTLIMITECPLA,
                                     @C_PROREC_CDTPPRATCPLA;
  END;
  DEALLOCATE C_PRODRECEITA;
/*Atualiza custo total das filiais agregadas ----------------------------------*/

  DECLARE C_CONSFILI CURSOR FOR
                (SELECT CDPRODACABADO, CDFILAGREGSERV, CDSERVFILAGREGA, CDTIPOPRAT, CDPRATO, CDFILAUXPRAT
                   FROM CONSFILIAGREGA
                  WHERE CDFILIAL = @P_CDFILCENT
                    AND DTRETIRADALANC = @P_DTRETIRADA)
  OPEN C_CONSFILI;

  FETCH NEXT FROM C_CONSFILI INTO @C_CONSFILI_CDPRODACABADO, @C_CONSFILI_CDFILAGREGSERV,
                                  @C_CONSFILI_CDSERVFILAGREGA, @C_CONSFILI_CDTIPOPRAT,
                                  @C_CONSFILI_CDPRATO, @C_CONSFILI_CDFILAUXPRAT;

  WHILE (@@FETCH_STATUS = 0) BEGIN
    SELECT @V_VRTOTAL = SUM(VRTOTARECEPRAT)
    FROM RECPRATPRODACAB
    WHERE CDFILIAL = @P_CDFILCENT
      AND DTRETIRADALANC = @P_DTRETIRADA
      AND CDPRODACABADO = @C_CONSFILI_CDPRODACABADO
      AND CDFILAGREGSERV = @C_CONSFILI_CDFILAGREGSERV
      AND CDSERVFILAGREGA = @C_CONSFILI_CDSERVFILAGREGA
      AND CDTIPOPRAT = @C_CONSFILI_CDTIPOPRAT
      AND CDPRATO = @C_CONSFILI_CDPRATO
      AND CDFILAUXPRAT = @C_CONSFILI_CDFILAUXPRAT;

    IF (@V_VRTOTAL IS NOT NULL) BEGIN
      UPDATE CONSFILIAGREGA
      SET VRTOTAPRODSERV = @V_VRTOTAL,
          VRUNITPRODSERV = @V_VRTOTAL/CASE QTPRODSERVCONS WHEN 0 THEN 1 ELSE QTPRODSERVCONS END
      WHERE CDFILIAL = @P_CDFILCENT
        AND DTRETIRADALANC = @P_DTRETIRADA
        AND CDPRODACABADO = @C_CONSFILI_CDPRODACABADO
        AND CDFILAGREGSERV = @C_CONSFILI_CDFILAGREGSERV
        AND CDSERVFILAGREGA = @C_CONSFILI_CDSERVFILAGREGA
        AND CDTIPOPRAT = @C_CONSFILI_CDTIPOPRAT
        AND CDPRATO = @C_CONSFILI_CDPRATO
        AND CDFILAUXPRAT = @C_CONSFILI_CDFILAUXPRAT;
    END;

    FETCH NEXT FROM C_CONSFILI INTO @C_CONSFILI_CDPRODACABADO, @C_CONSFILI_CDFILAGREGSERV,
                                  @C_CONSFILI_CDSERVFILAGREGA, @C_CONSFILI_CDTIPOPRAT,
                                  @C_CONSFILI_CDPRATO, @C_CONSFILI_CDFILAUXPRAT;
  END;
  DEALLOCATE C_CONSFILI;
  
/*Atualiza a quantidade de produto acabado total*/
  
  DECLARE C_PROACABADO CURSOR FOR
                  (SELECT PP.CDPRODACABADO, PP.CDTIPOPRAT
                     FROM PRODACABAPRATO PP
                    WHERE PP.CDFILIAL = @P_CDFILCENT
                      AND PP.DTRETIRADALANC = @P_DTRETIRADA)
  OPEN C_PROACABADO;

  FETCH NEXT FROM C_PROACABADO INTO @C_CONSFILI_CDPRODACABADO, @C_CONSFILI_CDTIPOPRAT;

  WHILE (@@FETCH_STATUS = 0) BEGIN
    SELECT @V_QTDETOTAL = SUM(QTPRODSERVCONS)
    FROM CONSFILIAGREGA
    WHERE CDFILIAL = @P_CDFILCENT
    AND DTRETIRADALANC = @P_DTRETIRADA
    AND CDPRODACABADO = @C_CONSFILI_CDPRODACABADO
    AND CDTIPOPRAT = @C_CONSFILI_CDTIPOPRAT;

    UPDATE PRODACABAPRATO 
    SET QTPRODACABADO = @V_QTDETOTAL
    WHERE CDFILIAL = @P_CDFILCENT
    AND DTRETIRADALANC = @P_DTRETIRADA
    AND CDPRODACABADO = @C_CONSFILI_CDPRODACABADO
    AND CDTIPOPRAT = @C_CONSFILI_CDTIPOPRAT;     

    FETCH NEXT FROM C_PROACABADO INTO @C_CONSFILI_CDPRODACABADO, @C_CONSFILI_CDTIPOPRAT;
  END;
  DEALLOCATE C_PROACABADO;
END;
GO
