ALTER TABLE FCT_FATURACONT MODIFY NRSEQCONTRATO NULL
/
ALTER TABLE FCT_APURACAO MODIFY NRSEQCONTRATO NULL
/
ALTER TABLE FCT_DADOSNF MODIFY NRSEQCONTRATO NULL
/
CREATE TABLE FCT_AGRUPAMENTO(
  NRAGRUPAMENTO	  		NUMBER 			NOT NULL,
  NMAGRUPAMENTO	  		VARCHAR2(250) 		NOT NULL,
  DSOBSAGRUPAMENTO 		VARCHAR2(400),
  NRORG                       	NUMBER 			DEFAULT 	 SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
  IDATIVO                    	VARCHAR2(1)     	DEFAULT 'S' NOT NULL
      CONSTRAINT CKC_IDATIVO_AGRUPAMEN 			CHECK (IDATIVO IN ('S','N')),
  DTINCLUSAO             	DATE                   	NULL,
  DTULTATU                  	DATE                  	NULL,
  NRORGINCLUSAO      		NUMBER             	DEFAULT 1 NULL,
  CDOPERINCLUSAO    		VARCHAR2(12)  		DEFAULT '1' NULL,
  NRORGULTATU          		NUMBER             	DEFAULT 1 NULL,
  CDOPERULTATU        		VARCHAR2(12)  		DEFAULT '1',
  NRGRUPOFATURA 		NUMBER,
  CDFILIAL 			VARCHAR2(4),
  NRPARCFATURA      		NUMBER
)
/
ALTER TABLE FCT_AGRUPAMENTO ADD CONSTRAINT PK_AGRUPAMENTO PRIMARY KEY  (NRAGRUPAMENTO)
/
ALTER TABLE FCT_AGRUPAMENTO ADD CONSTRAINT CKC_IDATIVO_AGRUPAMENTO CHECK (IDATIVO IN('S', 'N'))
/
ALTER TABLE FCT_AGRUPAMENTO ADD CONSTRAINT FKSM00200FILIAL_AGRUP FOREIGN KEY (CDFILIAL) REFERENCES FILIAL(CDFILIAL)
/
ALTER TABLE FCT_AGRUPAMENTO ADD CONSTRAINT FKSM00201GRUPFAT_AGRUP FOREIGN KEY (NRGRUPOFATURA) REFERENCES FCT_GRUPOFATURA(NRGRUPOFATURA)
/
ALTER TABLE FCT_AGRUPAMENTO ADD CONSTRAINT FKSM00202PARCNEGOCIO FOREIGN KEY (NRPARCFATURA) REFERENCES PARCNEGOCIO(NRPARCNEGOCIO)
/
CREATE TABLE FCT_RELACAGRUPAMENTOCONT(
  NRAGRUPAMENTOCONT 		NUMBER 			NOT NULL,
  NRAGRUPAMENTO     		NUMBER 			NOT NULL,
  NRSEQCONTRATO     		NUMBER 			NOT NULL,
  IDFATCONTJUNT     		VARCHAR2(4),
  NRORG                       	NUMBER 			DEFAULT 	 SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
  IDATIVO                    	VARCHAR2(1)     	DEFAULT 'S' NOT NULL
      CONSTRAINT CKC_IDATIVO_RELAGRUPCONT 		CHECK (IDATIVO IN ('S','N')),
  DTINCLUSAO             	DATE                   	NULL,
  DTULTATU                  	DATE                  	NULL,
  NRORGINCLUSAO      		NUMBER             	DEFAULT 1 NULL,
  CDOPERINCLUSAO    		VARCHAR2(12)  		DEFAULT '1' NULL,
  NRORGULTATU          		NUMBER             	DEFAULT 1 NULL,
  CDOPERULTATU        		VARCHAR2(12)  		DEFAULT '1'
)
/
ALTER TABLE FCT_RELACAGRUPAMENTOCONT ADD CONSTRAINT PK_RELACAGRUPCONT PRIMARY KEY(NRAGRUPAMENTOCONT)
/
ALTER TABLE FCT_RELACAGRUPAMENTOCONT ADD CONSTRAINT FKSM00203CONTRA_RELGRUPCONT
	FOREIGN KEY(NRSEQCONTRATO) REFERENCES FCT_CONTRATO(NRSEQCONTRATO)
/
ALTER TABLE FCT_RELACAGRUPAMENTOCONT ADD CONSTRAINT FKSM00204AGRUP_RELGRUPCONT
	FOREIGN KEY (NRAGRUPAMENTO) REFERENCES FCT_AGRUPAMENTO(NRAGRUPAMENTO)
/
ALTER TABLE FCT_RELACAGRUPAMENTOCONT ADD CONSTRAINT CKC_IDATIVO_RELACAGRUPCONT CHECK (IDATIVO IN('S', 'N'))
/
CREATE TABLE FCT_RELACAGRUPCONTFAT(
  NRAGRUPCONTFAT     		NUMBER NOT 		NULL,
  NRFATURACONT	   		NUMBER NOT 		NULL,
  IDPARCAGRUP    	   	VARCHAR(1) 		DEFAULT 'N',
  NRSEQCONTRATO	   		NUMBER,
  NRORG                       	NUMBER 			DEFAULT 	 SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
  IDATIVO                    	VARCHAR2(1)     	DEFAULT 'S' NOT NULL
      CONSTRAINT CKC_IDATIVO_RELAGRUPCONTFAT 		CHECK (IDATIVO IN ('S','N')),
  DTINCLUSAO             	DATE                   	NULL,
  DTULTATU                  	DATE                  	NULL,
  NRORGINCLUSAO      		NUMBER             	DEFAULT 1 NULL,
  CDOPERINCLUSAO    		VARCHAR2(12)  		DEFAULT '1' NULL,
  NRORGULTATU          		NUMBER             	DEFAULT 1 NULL,
  CDOPERULTATU        		VARCHAR2(12)  		DEFAULT '1',
  NRMEDICAOFATURA	   	NUMBER
)
/
ALTER TABLE FCT_RELACAGRUPCONTFAT ADD CONSTRAINT PK_AGRUPCONT_PARCAGRUP PRIMARY KEY (NRAGRUPCONTFAT)
/
ALTER TABLE FCT_RELACAGRUPCONTFAT ADD CONSTRAINT FKSM00205CONTRATO_PARCAGRUP
	FOREIGN KEY (NRSEQCONTRATO) REFERENCES FCT_CONTRATO(NRSEQCONTRATO)
/
ALTER TABLE FCT_RELACAGRUPCONTFAT ADD CONSTRAINT FKSM00206FATURA_AGRUPFAT
	FOREIGN KEY (NRFATURACONT) REFERENCES FCT_FATURACONT(NRFATURACONT)
/
ALTER TABLE FCT_RELACAGRUPCONTFAT ADD CONSTRAINT FKSM00207MEDICAO_AGRUPFAT
	FOREIGN KEY(NRMEDICAOFATURA) REFERENCES FCT_MEDICAOFATURA(NRMEDICAOFATURA)
/
ALTER TABLE FCT_RELACAGRUPCONTFAT ADD CONSTRAINT CKC_IDATIVO_PARCAGRUP CHECK (IDATIVO IN('S', 'N'))
/
ALTER TABLE FCT_RELACAGRUPCONTFAT ADD CONSTRAINT CKC_PARCAGRUP_PARCAGRUP CHECK (IDPARCAGRUP IN('S', 'N'))
/
CREATE TABLE FCT_RELACAPURACAOFATURA(
  NRAPURACAOFATURA  		NUMBER 			NOT NULL,
  NRAPURACAO        		NUMBER 			NOT NULL,
  NRFATURACONT      		NUMBER 			NOT NULL,
  NRORG                       	NUMBER 			DEFAULT 	 SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
  IDATIVO                    	VARCHAR2(1)     	DEFAULT 'S' NOT NULL
      CONSTRAINT CKC_IDATIVO_RELAPURAFATURA 		CHECK (IDATIVO IN ('S','N')),
  DTINCLUSAO             	DATE                   	NULL,
  DTULTATU                  	DATE                  	NULL,
  NRORGINCLUSAO      		NUMBER             	DEFAULT 1 NULL,
  CDOPERINCLUSAO    		VARCHAR2(12)  		DEFAULT '1' NULL,
  NRORGULTATU          		NUMBER             	DEFAULT 1 NULL,
  CDOPERULTATU        		VARCHAR2(12)  		DEFAULT '1'
)
/
ALTER TABLE FCT_RELACAPURACAOFATURA ADD CONSTRAINT PK_RELACAPURACAOFATURA PRIMARY KEY (NRAPURACAOFATURA)
/
ALTER TABLE FCT_RELACAPURACAOFATURA ADD CONSTRAINT FKSM00208APURAC_APURACFATU
  FOREIGN KEY (NRAPURACAO) REFERENCES FCT_APURACAO(NRAPURACAO)
/
ALTER TABLE FCT_RELACAPURACAOFATURA ADD CONSTRAINT FKSM00209FATURA_APURACFATU
  FOREIGN KEY (NRFATURACONT) REFERENCES FCT_FATURACONT(NRFATURACONT)
/
ALTER TABLE FCT_RELACAPURACAOFATURA ADD CONSTRAINT CKC_IDATIVO_APURACAOFATURA CHECK (IDATIVO IN('S', 'N'))